package HeroList;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;


/**
 * @author jessehonkalinna, ant
 * @version Mar 26, 2025
 *
 */
public class Abilities implements Iterable<Ability> {
    
    private boolean muutettu = false;
    
    private final Collection<Ability> alkiot = new ArrayList<Ability>();
    /**
     * @param har kesken
     */
    public void lisaa(Ability har) {
                alkiot.add(har);
                muutettu = true;
             }
    

    public void lueTiedostosta(String hakemisto) throws StorageException {
        String tiedostoNimi = hakemisto + "/abilities.dat";
        try (BufferedReader br = new BufferedReader(new FileReader(tiedostoNimi))) {
            String line;
            while ((line = br.readLine()) != null) {
                Ability ab = new Ability();
                ab.parse(line);
                alkiot.add(ab);
            }
        } catch (IOException e) {
            throw new StorageException("Virhe tiedoston lukemisessa: " + e.getMessage());
        }
    }
    
    /**
     * Tallentaa kyvyt tiedostoon.
     * @param hakemisto hakemiston nimi, esim. "aineisto"
     * @throws StorageException jos tallennus epäonnistuu
     */
    public void tallenna(String hakemisto) throws StorageException {

        File dir = new File(hakemisto);
        if (!dir.exists()) dir.mkdirs();

        String tiedostoNimi = hakemisto + "/abilities.dat";
        try (BufferedWriter bw = new BufferedWriter(new FileWriter(tiedostoNimi))) {
            for (Ability ab : alkiot) {
                bw.write(ab.toString());
                bw.newLine();
            }
        } catch (IOException e) {
            throw new StorageException("Virhe tiedoston tallentamisessa: " + e.getMessage());
        }
    }

   // /**
   //  * @throws StorageException antaa poikkeuksen jos ei toimi
   //  */
   // public void tallenna() throws StorageException {
   //     if ( !muutettu ) return;
   //
   //     File fbak = new File(getBakNimi());
   //     File ftied = new File(getTiedostonNimi());
   //     fbak.delete(); //  if ... System.err.println("Ei voi tuhota");
   //     ftied.renameTo(fbak); //  if ... System.err.println("Ei voi nimetä");
   //
   //     try ( PrintWriter fo = new PrintWriter(new FileWriter(ftied.getCanonicalPath())) ) {
   //         for (Ability har : this) {
   //             fo.println(har.toString());
   //         }
   //     } catch ( FileNotFoundException ex ) {
   //         throw new StorageException("Tiedosto " + ftied.getName() + " ei aukea");
   //     } catch ( IOException ex ) {
   //         throw new StorageException("Tiedoston " + ftied.getName() + " kirjoittamisessa ongelmia");
   //     }
   //
   //     muutettu = false;
   // }
    
    /**
     * @return palauttaa lukumäärän
     */
    public int getLkm() {
        return alkiot.size();
    }

    
    /**
     * @param tunnusnro kesken
     * @return kesken
     */
    public List<Ability> annaAbilities(int tunnusnro) {
                List<Ability> loydetyt = new ArrayList<Ability>();
                 for (Ability har : alkiot)
                     if ( har.getAbilityId() == tunnusnro ) loydetyt.add(har);
                 return loydetyt;
             }

    /**
     * @param args syöte
     */
    public static void main(String[] args) {
        Abilities ab = new Abilities();
        Ability pitsi1 = new Ability();
        pitsi1.vastaaPitsinNyplays(2);
        Ability pitsi2 = new Ability();
        pitsi2.vastaaPitsinNyplays(1);
        Ability pitsi3 = new Ability();
        pitsi3.vastaaPitsinNyplays(2);
        Ability pitsi4 = new Ability();
        pitsi4.vastaaPitsinNyplays(2);

        ab.lisaa(pitsi1);
        ab.lisaa(pitsi2);
        ab.lisaa(pitsi3);
        ab.lisaa(pitsi2);
        ab.lisaa(pitsi4);

        System.out.println("============= Abilities testi =================");

        List<Ability> Abilities2 = ab.annaAbilities(2);

        for (Ability har : Abilities2) {
            System.out.print(har.getAbilityId() + " ");
            har.tulosta(System.out);
        }

    }
 

    @Override
    public Iterator<Ability> iterator() {
        return alkiot.iterator();
    }


}