package HeroList;

import java.io.OutputStream;
import java.io.PrintStream;
import fi.jyu.mit.ohj2.Mjonot;

/**
 * @author ant
 * @version 10 Apr 2025
 *
 */
public class Ability {
    private int aID; //ability ID
    private String ability;
    private String description;
    
    private static int seuraavaNro = 1;

    
    /**
     * @param id1 parametri
     */
    public Ability(int id1) {
        // Vielä ei tarvita mitään
    }
    
    /**
     * 
     */
    public Ability() {
        // TODO Auto-generated constructor stub
    }


    /**
     * @return palauttaa abilityn id
     */
    public int getaID() {
        return aID;
    }

    /**
     * antaa abilitylle id
     * @param aID parametri
     */
    public void setaID(int aID) {
        this.aID = aID;
    }


    /**
     * @return palauttaa abilityn
     */
    public String getAbility() {
        return ability;
    }

    /**
     * asettaa abilityn
     * @param ability annetaan ability parametriksi
     */
    public void setAbility(String ability) {
        this.ability = ability;
    }

    /**
     * @return palauttaa kuvauksen
     */
    public String getDescription() {
        return description;
    }

    /**
     * @param description annetaan parametriksi heron kuvaus
     */
    public void setDescription(String description) {
        this.description = description;
    }

    
    /**
     * @return palauttaa abilityn id
     */
    public int getAbilityId() {
        return aID;
    }
    
    /**
     * @param i parametriksi numero
     */
    public void vastaaPitsinNyplays(int i) {
        aID = 5;
        ability = "Archery";
        description = "Can hit moving targets up to 70 meters away.";
    }

    /**
     * @return abilityn id
     */
    public int rekisteroi() {
        aID = seuraavaNro;
        seuraavaNro++;
        return aID;
    }

    /**
     * @param out tulostus
     */
    public void tulosta(PrintStream out) {
        out.println(aID + " " + ability + " " + description);
    }
    
    /**
     * @param os tulostus
     */
    public void tulosta(OutputStream os) {
        tulosta(new PrintStream(os));
    }
    
    /**
    private void setAbilityId(int nr) {
        int abilityId = nr;
        if ( abilityId >= seuraavaNro ) seuraavaNro = abilityId + 1;
    }
    */

    /**
     * Selvitää abilityn tiedot | erotellusta merkkijonosta.
     * @param rivi josta abilityn tiedot otetaan
     * @example
     * <pre name="test">
     *   Ability ability = new Ability();
     *   ability.parse("  10  |   Archer  | Can hit moving targets up to 70 meters away.");
     *   ability.getAbilityId() === 10;
     *   ability.toString()    === "10|Archer|Can hit moving targets up to 70 meters away.";
     * </pre>
     */

    public void parse(String rivi) {
        StringBuffer sb = new StringBuffer(rivi);
        aID = Mjonot.erota(sb, '|', aID);
        ability = Mjonot.erota(sb, '|', ability);
        description = Mjonot.erota(sb, '|', description);
    }
    
    
    /**
     * Palauttaa abilityn tiedot merkkijonona jonka voi tallentaa tiedostoon.
     * @return ability tolppaeroteltuna merkkijonona 
     * @example
     * <pre name="test">
     *   Ability ability = new Ability();
     *   ability.parse("  5  |   Archery  | Can hit moving targets up to 70 meters away.");
     *   ability.toString()    === "5|Archery|Can hit moving targets up to 70 meters away.";
     * </pre>
     */

    @Override
    public String toString() {
        return "" + getAbilityId() + "|" + ability + "|" + description;
    }
    
    @Override
    public boolean equals(Object obj) {
        if ( obj == null ) return false;
        return this.toString().equals(obj.toString());
    }

    @Override
    public int hashCode() {
        return aID;
    }

    /**
     * @param args testiohjelma
     */
    public static void main(String[] args) {
        Ability har = new Ability();
        har.vastaaPitsinNyplays(1);
        har.tulosta(System.out);
    }
   
}
