package HeroList;

import java.io.File;
import java.util.Collection;
import java.util.List;

/**
 * @author jessehonkalinna
 * @version Apr 10, 2025
 *
 */
public class HeroListPaa {
    private Heroes heroes = new Heroes();
    private Abilities abilities = new Abilities();
    //private NamesToAbilities namesToAbilities= new NamesToAbilities();
    
    /**
     * @param nro ei käytössä
     * @return ei käytössä
     */
    public int poista(@SuppressWarnings("unused") int nro) {
        return 0;
    }

    
    /**
     * @param hero annettu hero
     * @throws StorageException virhekäsittely
     */
    public void add(Hero hero) throws StorageException {
        heroes.add(hero);
    }

    
    /**
     * Listään uusi harrastus kerhoon
     * @param har lisättävä harrastus 
     * @throws StorageException jos tulee ongelmia
     */

    public void lisaa(Ability har) throws StorageException {
        abilities.lisaa(har);
    }
    
    /** 
     * Palauttaa "taulukossa" hakuehtoon vastaavien jäsenten viitteet 
     * @param hakuehto hakuehto  
     * @param k etsittävän kentän indeksi  
     * @return tietorakenteen löytyneistä jäsenistä 
     * @throws StorageException Jos jotakin menee väärin
     */ 
    public Collection<Hero> etsi(String hakuehto, int k) throws StorageException { 
        return heroes.etsi(hakuehto, k); 
    }

    /**
     * Haetaan kaikki jäsen harrastukset
     * @param hero hero jolle harrastuksia haetaan
     * @return tietorakenne jossa viiteet löydetteyihin harrastuksiin
     * @throws StorageException jos tulee ongelmia
     * @example
     * <pre name="test">
     * #THROWS SailoException
     * #import java.util.*;
     * 
     *  Kerho kerho = new Kerho();
     *  loytyneet.get(0) == pitsi21 === true;
     * </pre> 
     */

    public List<Ability> annaAbilities(Hero hero) throws StorageException {
        return abilities.annaAbilities(hero.getHeroId());
    }



   /**
    * Lukee kerhon tiedot tiedostosta
    * @param hakemisto hakemiston nimi
    * @throws StorageException jos lukeminen epäonnistuu
    */
   public void lueTiedostosta(String hakemisto) throws StorageException {
       heroes = new Heroes();
       abilities = new Abilities();
       heroes.lueTiedostosta("aineisto");
       abilities.lueTiedostosta("aineisto");
   }


 

   
   /**
    * Tallenttaa kerhon tiedot tiedostoon.  
    * Vaikka jäsenten tallettamien epäonistuisi, niin yritetään silti tallettaa
    * harrastuksia ennen poikkeuksen heittämistä.
    * @throws StorageException jos tallettamisessa ongelmia
    */

   public void tallenna() throws StorageException {
       String virhe = "";
       try {
           heroes.tallenna("aineisto");
       } catch ( StorageException ex ) {
           virhe = ex.getMessage();
       }

       try {
           abilities.tallenna("aineisto");
       } catch ( StorageException ex ) {
           virhe += ex.getMessage();
       }
       if ( !"".equals(virhe) ) throw new StorageException(virhe);
   }



    
    /**
     * Testiohjelma kerhosta
     * @param args ei käytössä
     */
   public static void main(String args[]) {
       HeroListPaa herolistpaa = new HeroListPaa();
  
       try {
           // HeroListPaa.lueTiedostosta("Herot");
  
           Hero aku1 = new Hero(), aku2 = new Hero();
           aku1.rekisteroi();
           aku1.vastaaAkuAnkka();
           aku2.rekisteroi();
           aku2.vastaaAkuAnkka();
  
           herolistpaa.add(aku1);
           herolistpaa.add(aku2);
           int id1 = aku1.getHeroId();
           int id2 = aku2.getHeroId();
           Ability pitsi11 = new Ability(id1); 
           pitsi11.vastaaPitsinNyplays(id1); 
           herolistpaa.lisaa(pitsi11);
           Ability pitsi12 = new Ability(id1); 
           pitsi12.vastaaPitsinNyplays(id1); 
           herolistpaa.lisaa(pitsi12);
           Ability pitsi21 = new Ability(id2); 
           pitsi21.vastaaPitsinNyplays(id2); 
           herolistpaa.lisaa(pitsi21);
           Ability pitsi22 = new Ability(id2); 
           pitsi22.vastaaPitsinNyplays(id2); 
           herolistpaa.lisaa(pitsi22);
           Ability pitsi23 = new Ability(id2); 
           pitsi23.vastaaPitsinNyplays(id2); 
           herolistpaa.lisaa(pitsi23);
  
           System.out.println("============= Kerhon testi =================");
           Collection<Hero> heroes = herolistpaa.etsi("", -1);
           int i = 0;

           for (Hero hero: heroes) {
               System.out.println("Hero paikassa: " + i);
               hero.print(System.out);
               List<Ability> loytyneet = herolistpaa.annaAbilities(hero);
               for (Ability ability : loytyneet)
                   ability.tulosta(System.out);
               i++;
           }
  
       } catch (StorageException ex) {
           System.out.println(ex.getMessage());
       }
   }


    
}
