package fxHeroList;


import java.io.PrintStream;
import java.util.List;

import HeroList.Ability;
import HeroList.Hero;
import HeroList.HeroListPaa;
import HeroList.StorageException;
import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ListChooser;
import fi.jyu.mit.fxgui.StringAndObject;
import fi.jyu.mit.fxgui.TextAreaOutputStream;
import javafx.application.Platform;
import javafx.fxml.FXML;
import javafx.scene.control.Label;
import javafx.scene.control.ListView;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.scene.layout.GridPane;

/**
 * @author jessehonkalinna
 * @version 6.2.2025
 *
 */
public class HeroListGUIController {

    @FXML
    private void handleNewHero() {
        newHero();
    }


    @FXML
    private void handleNewAbility() throws StorageException {
         newAbility();
    }
    
    /**
     * 
     */
    @FXML
    public void handleClose() {
        Platform.exit();
    }
    
    /**
     * 
     */
    @FXML
    public void handleHelp() {
        Dialogs.showMessageDialog("Work in progress!");
    }


    /**
     * 
     */
    @FXML
    public void handleAbout() {
        Dialogs.showMessageDialog("Work in progress!");
    }
    
    /**
     * 
     */
    @FXML
    public void handlePrint() {
        Dialogs.showMessageDialog("Work in progress!");
    }

    /**
     * 
     */
    @FXML
    public void handleDelete() {
        Dialogs.showMessageDialog("Work in progress!");
    }
    
    /**
     * 
     */
    @FXML
    public void handleDeleteHero() {
        Dialogs.showMessageDialog("Work in pqrogress!");
    }
    
    @FXML private void handleHakuehto() {
       return; 
    }


    @FXML
    private GridPane panelHero;
    @FXML
    private ListChooser<Hero> chooserHeroes;
    @FXML
    private ListChooser<Ability> chooserAbilities;
    @FXML
    private ListView<StringAndObject<Hero>> cbKentat;
    @FXML
    private TextField hakuehto;
    @FXML
    private Label labelVirhe;

    private HeroListPaa heroList;
    private TextArea areaHero = new TextArea();
    private Hero heroKohdalla;

    /**
     * @param heroList ei käytössä vielä
     */
    public void setHeroList(HeroListPaa heroList) {
        this.heroList = heroList;
        naytaHero();
    }

   // private void naytaVirhe(String virhe) {
   //     if ( virhe == null || virhe.isEmpty() ) {
   //         labelVirhe.setText("");
   //         return;
   //     }
   //     labelVirhe.setText(virhe);
   // }



  ////**
  /// * @param hId hakee heron
  /// */
  ///protected void hae(int hId) {
  ///    int k = cbKentat.getSelectionModel().getSelectedIndex();
  ///    String ehto = hakuehto.getText(); 
  ///    if (k > 0 || ehto.length() > 0)
  ///        naytaVirhe(String.format("Ei osata hakea (kenttä: %d, ehto: %s)", k, ehto));
  ///    else
  ///        naytaVirhe(null);
  ///    
  ///    chooserHeroes.clear();
  ///
  ///    int index = 0;
  ///    Collection<Hero> heroes;
  ///    try {
  ///        heroes = heroList.etsi(ehto, k);
  ///        int i = 0;
  ///        for (Hero hero:heroes) {
  ///            if (hero.getHeroId() == hId) index = i;
  ///            chooserHeroes.add(hero.getName(), hero);
  ///            i++;
  ///        }
  ///    } catch (StorageException ex) {
  ///        Dialogs.showMessageDialog("Heron hakemisessa ongelmia! " + ex.getMessage());
  ///    }
  ///    chooserHeroes.setSelectedIndex(index); // tästä tulee muutosviesti joka näyttää jäsenen
  ///}
    
    /**
     * @param hId hakee abilityn
     * @throws StorageException virhekäsittely
     */
    protected void haeAbility(int hId) throws StorageException {
        chooserAbilities.clear(); // Tyhjennetään lista ennen päivittämistä

        List<Ability> abilities = heroList.annaAbilities(heroKohdalla); // Haetaan sankarin kyvyt
        int index = 0;

        for (Ability ability : abilities) {
            if (ability.getaID() == hId) // Verrataan oikeaan ID:hen
                index = chooserAbilities.getItems().size(); // Tallennetaan nykyinen indeksi

            chooserAbilities.add(ability.getAbility(), ability); // Lisätään kyky listaan
        }

        chooserAbilities.setSelectedIndex(index); // Valitaan oikea kyky
    }

    /**
     * 
     */
    protected void naytaHero() {
        heroKohdalla = chooserHeroes.getSelectedObject();

        if (heroKohdalla == null)
            return;

        areaHero.setText("");
        try (PrintStream os = TextAreaOutputStream
                .getTextPrintStream(areaHero)) {
            heroKohdalla.print(os);
        }

    }


    /**
     * 
     */
    public void newHero() {
        Hero uusi = new Hero();
        uusi.registerHeroId();
        uusi.vastaaPitsinNyplays();
        try {
            heroList.add(uusi);
        } catch (StorageException e) {
            Dialogs.showMessageDialog(
                    "Ongelmia uuden luomisessa " + e.getMessage());
            return;
        }
       ;
    }

    /**
     * @throws StorageException  virhekäsittely
     * 
     */
    public void newAbility() throws StorageException {
        if (heroKohdalla == null)
            return;
        Ability har = new Ability();
        har.rekisteroi();
        har.vastaaPitsinNyplays(heroKohdalla.getHeroId());
        heroList.lisaa(har);
        //hae(heroKohdalla.getHeroId());
    }


    /**
     * @param os tulostus
     * @param hero hero
     * @throws StorageException  virhekäsittely
     */
    public void tulosta(PrintStream os, final Hero hero) throws StorageException {
        os.println("----------------------------------------------");
        hero.print(os);
        os.println("----------------------------------------------");
        List<Ability> harrastukset = heroList.annaAbilities(hero);
        for (Ability har : harrastukset)
            har.tulosta(os);
        
    }


    /**
     * @param string lukee tiedostoa
     */
    public void lueTiedosto(@SuppressWarnings({ "unused" }) String string) {
        // TODO Auto-generated method stub
        
    }
    
}