package fxHeroList;

import HeroList.HeroListPaa;
import javafx.application.Application;
import javafx.application.Platform;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.layout.Pane;
import javafx.fxml.FXMLLoader;


/**
 * @author jessehonkalinna
 * @version 6.2.2025
 *
 */
public class HeroListMain extends Application {
    
    
    @Override
    public void start(Stage primaryStage) {
        try {
            final FXMLLoader ldr = new FXMLLoader(getClass().getResource("HeroListGUIView.fxml"));
            final Pane root = (Pane)ldr.load();
            final HeroListGUIController herolistCtrl = (HeroListGUIController) ldr.getController();
            final Scene scene = new Scene(root);
        
            scene.getStylesheets().add(getClass().getResource("herolist.css").toExternalForm());
            primaryStage.setScene(scene);
            primaryStage.setTitle("HeroList");
            
            HeroListPaa herolist = new HeroListPaa();
            herolistCtrl.setHeroList(herolist);
            
            Application.Parameters params = getParameters();
            if (params.getRaw().size() > 0) {
                herolistCtrl.lueTiedosto(params.getRaw().get(0));
            }
            
            primaryStage.show();
        } catch(Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * @param args Ei kaytossa
     */
    public static void main(String[] args) {
        launch(args);
    }
}